"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _anyPass2 = require("ramda/src/anyPass");

var _anyPass3 = _interopRequireDefault(_anyPass2);

var _always2 = require("ramda/src/always");

var _always3 = _interopRequireDefault(_always2);

var _when2 = require("ramda/src/when");

var _when3 = _interopRequireDefault(_when2);

var _filter2 = require("ramda/src/filter");

var _filter3 = _interopRequireDefault(_filter2);

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _cond2 = require("ramda/src/cond");

var _cond3 = _interopRequireDefault(_cond2);

var _both2 = require("ramda/src/both");

var _both3 = _interopRequireDefault(_both2);

var _T2 = require("ramda/src/T");

var _T3 = _interopRequireDefault(_T2);

var _propEq2 = require("ramda/src/propEq");

var _propEq3 = _interopRequireDefault(_propEq2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handlePlusTagFilter = [(0, _prop3.default)("plusTag"), function (_ref) {
	var plusTag = _ref.plusTag;
	return function (_ref2) {
		var tags = _ref2.tags;
		return (tags || []).includes(plusTag);
	};
}];

var handleProjectFilter = [(0, _propEq3.default)("prop", "project"), function (_ref3) {
	var value = _ref3.value;
	return function (_ref4) {
		var project = _ref4.project;
		return (project || "").includes(value);
	};
}];

var defaultPropValueFilter = [_T3.default, function (_ref5) {
	var prop = _ref5.prop,
	    value = _ref5.value;
	return function (task) {
		return task[prop] === value;
	};
}];

var handlePropValueFilter = [(0, _both3.default)((0, _prop3.default)("prop"), (0, _prop3.default)("value")), (0, _cond3.default)([handleProjectFilter, defaultPropValueFilter])];

var handleIdFilter = [(0, _prop3.default)("int"), function (_ref6) {
	var int = _ref6.int;
	return function (_ref7) {
		var id = _ref7.id;
		return int === id;
	};
}];

var filterByCLICommands = (0, _pipe3.default)((0, _map3.default)((0, _cond3.default)([handlePlusTagFilter, handlePropValueFilter, handleIdFilter])), (0, _filter3.default)(Boolean), (0, _when3.default)((0, _propEq3.default)("length", 0), (0, _always3.default)([_T3.default])), _anyPass3.default);

exports.default = filterByCLICommands;