"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _flatten2 = require("ramda/src/flatten");

var _flatten3 = _interopRequireDefault(_flatten2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

var _jecJask = require("jec-jask");

var _modifyByCLICommands = require("./modifyByCLICommands");

var _modifyByCLICommands2 = _interopRequireDefault(_modifyByCLICommands);

var _filterByCLICommands = require("./filterByCLICommands");

var _filterByCLICommands2 = _interopRequireDefault(_filterByCLICommands);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var generateModifyActions = function generateModifyActions(_ref) {
	var state = _ref.state,
	    filter = _ref.filter,
	    modifications = _ref.modifications;

	var filterUUIDs = (0, _filterByCLICommands2.default)(filter);
	var applyToUUIDs = (0, _jecJask.collateAllObjects)(state).filter(filterUUIDs).map((0, _prop3.default)("uuid"));

	var generateActions = (0, _pipe3.default)((0, _modifyByCLICommands2.default)(state), (0, _map3.default)(function (action) {
		return applyToUUIDs.map(function (objId) {
			return (0, _extends3.default)({}, action, {
				objId: objId
			});
		});
	}), _flatten3.default);

	return {
		actions: generateActions(modifications),
		filterForRender: filterUUIDs
	};
};

exports.default = generateModifyActions;