"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _T2 = require("ramda/src/T");

var _T3 = _interopRequireDefault(_T2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

var _jecJask = require("jec-jask");

var _filterByCLICommands = require("./filterByCLICommands");

var _filterByCLICommands2 = _interopRequireDefault(_filterByCLICommands);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var generateWorkflowEventActions = function generateWorkflowEventActions(eventName) {
	return function (_ref) {
		var state = _ref.state,
		    filter = _ref.filter;

		var filterUUIDs = (0, _filterByCLICommands2.default)(filter);
		var applyToUUIDs = (0, _jecJask.collateAllObjects)(state).filter(filterUUIDs).map((0, _prop3.default)("uuid"));

		var actions = applyToUUIDs.map(function (objId) {
			return {
				objId: objId,
				prop: eventName,
				type: "SET_PROP",
				value: new Date().toISOString()
			};
		});

		return {
			actions: actions,
			filterForRender: eventName === "done" ? _T3.default : filterUUIDs
		};
	};
};

exports.default = generateWorkflowEventActions;