"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _filter2 = require("ramda/src/filter");

var _filter3 = _interopRequireDefault(_filter2);

var _flatten2 = require("ramda/src/flatten");

var _flatten3 = _interopRequireDefault(_flatten2);

var _both2 = require("ramda/src/both");

var _both3 = _interopRequireDefault(_both2);

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _T2 = require("ramda/src/T");

var _T3 = _interopRequireDefault(_T2);

var _cond2 = require("ramda/src/cond");

var _cond3 = _interopRequireDefault(_cond2);

var _find2 = require("ramda/src/find");

var _find3 = _interopRequireDefault(_find2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toPairs2 = require("ramda/src/toPairs");

var _toPairs3 = _interopRequireDefault(_toPairs2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _split2 = require("ramda/src/split");

var _split3 = _interopRequireDefault(_split2);

var _toUpper2 = require("ramda/src/toUpper");

var _toUpper3 = _interopRequireDefault(_toUpper2);

var _propEq2 = require("ramda/src/propEq");

var _propEq3 = _interopRequireDefault(_propEq2);

var _defaultTo2 = require("ramda/src/defaultTo");

var _defaultTo3 = _interopRequireDefault(_defaultTo2);

var _lensProp2 = require("ramda/src/lensProp");

var _lensProp3 = _interopRequireDefault(_lensProp2);

var _over2 = require("ramda/src/over");

var _over3 = _interopRequireDefault(_over2);

var _2 = require("ramda/src/__");

var _3 = _interopRequireDefault(_2);

var _contains2 = require("ramda/src/contains");

var _contains3 = _interopRequireDefault(_contains2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _v = require("uuid/v4");

var _v2 = _interopRequireDefault(_v);

var _parseDateTime = require("./parseDateTime");

var _parseDateTime2 = _interopRequireDefault(_parseDateTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseTimeShortcutValues = [(0, _pipe3.default)((0, _prop3.default)("prop"), (0, _contains3.default)(_3.default, ["due", "wait", "stop", "start"])), (0, _pipe3.default)((0, _over3.default)((0, _lensProp3.default)("value"), _parseDateTime2.default), (0, _over3.default)((0, _lensProp3.default)("type"), (0, _defaultTo3.default)("SET_PROP")))];

var parseRecurShortcutValues = [(0, _propEq3.default)("prop", "recur"), (0, _pipe3.default)((0, _over3.default)((0, _lensProp3.default)("value"), _parseDateTime.parseRecur), (0, _over3.default)((0, _lensProp3.default)("type"), (0, _defaultTo3.default)("SET_PROP")))];

var parsePriorityValues = [(0, _propEq3.default)("prop", "priority"), (0, _pipe3.default)((0, _over3.default)((0, _lensProp3.default)("value"), _toUpper3.default), (0, _over3.default)((0, _lensProp3.default)("type"), (0, _defaultTo3.default)("SET_PROP")))];

var generateProjectActions = function generateProjectActions(_ref) {
	var projects = _ref.projects;
	return [(0, _propEq3.default)("prop", "project"), (0, _pipe3.default)((0, _over3.default)((0, _lensProp3.default)("value"), (0, _split3.default)(".")), function (_ref2) {
		var value = _ref2.value,
		    rest = (0, _objectWithoutProperties3.default)(_ref2, ["value"]);

		var keyValuePairs = (0, _toPairs3.default)(projects);

		var actions = [];
		var prevSubProjectId = undefined;

		var _loop = function _loop(subProjectName) {
			var _ref3 = (0, _find3.default)(function (_ref5) {
				var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
				    id = _ref6[0],
				    _ref6$ = _ref6[1],
				    name = _ref6$.name,
				    parent = _ref6$.parent;

				return name === subProjectName && parent === prevSubProjectId;
			}, keyValuePairs) || [],
			    _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
			    existantProjectId = _ref4[0],
			    _ref4$ = _ref4[1];

			_ref4$ = _ref4$ === undefined ? {} : _ref4$;
			var existantProjectName = _ref4$.name,
			    existantProjectParent = _ref4$.parent;


			if (existantProjectId) {
				prevSubProjectId = existantProjectId;
				return "continue";
			} else {
				var projectId = (0, _v2.default)();
				actions.push({
					type: "SET_PROJECT",
					name: subProjectName,
					parent: prevSubProjectId,
					projectId: projectId
				});
				prevSubProjectId = projectId;
				return "continue";
			}
		};

		var _iteratorNormalCompletion = true;
		var _didIteratorError = false;
		var _iteratorError = undefined;

		try {
			for (var _iterator = value[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
				var subProjectName = _step.value;

				var _ret = _loop(subProjectName);

				if (_ret === "continue") continue;
			}
		} catch (err) {
			_didIteratorError = true;
			_iteratorError = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion && _iterator.return) {
					_iterator.return();
				}
			} finally {
				if (_didIteratorError) {
					throw _iteratorError;
				}
			}
		}

		actions.push({
			type: "SET_PROP",
			prop: "project",
			value: prevSubProjectId
		});

		return actions;
	})];
};

var handlePropValueModification = function handlePropValueModification(state) {
	return (0, _pipe3.default)((0, _cond3.default)([parseTimeShortcutValues, parseRecurShortcutValues, parsePriorityValues, generateProjectActions(state), [_T3.default, (0, _over3.default)((0, _lensProp3.default)("type"), (0, _defaultTo3.default)("SET_PROP"))]]));
};

var handlePlusTagModification = function handlePlusTagModification(_ref7) {
	var plusTag = _ref7.plusTag;
	return {
		type: "ADD_TAG_TO_OBJ",
		tag: plusTag
	};
};

var modifyByCLICommand = function modifyByCLICommand(state) {
	return (0, _pipe3.default)((0, _map3.default)((0, _pipe3.default)((0, _cond3.default)([[(0, _both3.default)((0, _prop3.default)("prop"), (0, _prop3.default)("value")), handlePropValueModification(state)], [(0, _prop3.default)("plusTag"), handlePlusTagModification]]))), _flatten3.default, (0, _filter3.default)(Boolean));
};

exports.default = modifyByCLICommand;