"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _evolve2 = require("ramda/src/evolve");

var _evolve3 = _interopRequireDefault(_evolve2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _2 = require("ramda/src/__");

var _3 = _interopRequireDefault(_2);

var _contains2 = require("ramda/src/contains");

var _contains3 = _interopRequireDefault(_contains2);

var _splitWhen2 = require("ramda/src/splitWhen");

var _splitWhen3 = _interopRequireDefault(_splitWhen2);

var _slice2 = require("ramda/src/slice");

var _slice3 = _interopRequireDefault(_slice2);

var _filter2 = require("ramda/src/filter");

var _filter3 = _interopRequireDefault(_filter2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _reduce2 = require("ramda/src/reduce");

var _reduce3 = _interopRequireDefault(_reduce2);

var _T2 = require("ramda/src/T");

var _T3 = _interopRequireDefault(_T2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _split2 = require("ramda/src/split");

var _split3 = _interopRequireDefault(_split2);

var _objOf2 = require("ramda/src/objOf");

var _objOf3 = _interopRequireDefault(_objOf2);

var _replace2 = require("ramda/src/replace");

var _replace3 = _interopRequireDefault(_replace2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _test2 = require("ramda/src/test");

var _test3 = _interopRequireDefault(_test2);

var _cond2 = require("ramda/src/cond");

var _cond3 = _interopRequireDefault(_cond2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseDataInterface = (0, _cond3.default)([[(0, _test3.default)(/^\+\w+/), (0, _pipe3.default)((0, _replace3.default)("+", ""), (0, _objOf3.default)("plusTag"))], [(0, _test3.default)(/^-\w+/), (0, _pipe3.default)((0, _replace3.default)("-", ""), (0, _objOf3.default)("minusTag"))], [(0, _test3.default)(/[\w ]+:[\w ]+/), (0, _pipe3.default)((0, _split3.default)(":"), function (_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
	    prop = _ref2[0],
	    value = _ref2[1];

	return {
		prop: prop,
		value: value
	};
})], [function (x) {
	return parseInt(x, 10);
}, function (x) {
	return { int: parseInt(x, 10) };
}], [_T3.default, function (plain) {
	return { plain: plain };
}]]);

var combinePlains = (0, _pipe3.default)((0, _reduce3.default)(function (_ref3, val) {
	var arr = _ref3.arr,
	    plain = _ref3.plain;

	if (val.plain) {
		return {
			arr: arr,
			plain: plain.length ? plain + " " + val.plain : val.plain
		};
	} else {
		return {
			arr: [].concat((0, _toConsumableArray3.default)(arr), [val]),
			plain: plain
		};
	}
}, {
	arr: [],
	plain: ""
}), function (_ref4) {
	var arr = _ref4.arr,
	    plain = _ref4.plain;
	return [].concat((0, _toConsumableArray3.default)(arr), [plain.length ? { prop: "description", value: plain } : null]);
}, (0, _filter3.default)(Boolean));

var commandStrings = ["add", "modify", "delete", "start", "stop", "done"];

var parseCli = (0, _pipe3.default)((0, _slice3.default)(2, Infinity), (0, _splitWhen3.default)((0, _contains3.default)(_3.default, commandStrings)), function (_ref5) {
	var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
	    filter = _ref6[0],
	    _ref6$ = (0, _toArray3.default)(_ref6[1]),
	    command = _ref6$[0],
	    modifications = _ref6$.slice(1);

	return {
		filter: filter,
		command: command,
		modifications: modifications
	};
}, (0, _evolve3.default)({
	filter: (0, _map3.default)(parseDataInterface),
	modifications: (0, _map3.default)(parseDataInterface)
}), (0, _evolve3.default)({
	filter: combinePlains,
	modifications: combinePlains
}));

exports.default = parseCli;