"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.parseRecur = exports.parseFrom = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _T2 = require("ramda/src/T");

var _T3 = _interopRequireDefault(_T2);

var _test2 = require("ramda/src/test");

var _test3 = _interopRequireDefault(_test2);

var _cond2 = require("ramda/src/cond");

var _cond3 = _interopRequireDefault(_cond2);

var _head2 = require("ramda/src/head");

var _head3 = _interopRequireDefault(_head2);

var _match2 = require("ramda/src/match");

var _match3 = _interopRequireDefault(_match2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _chronoNode = require("chrono-node");

var _chronoNode2 = _interopRequireDefault(_chronoNode);

var _dateFns = require("date-fns");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var extractNumber = function extractNumber(adder, ref) {
	return (0, _pipe3.default)((0, _match3.default)(/\d+/), _head3.default, function (x) {
		return parseInt(x, 10);
	}, function (x) {
		return adder(ref, x);
	});
};

var parseFrom = exports.parseFrom = function parseFrom(ref) {
	return (0, _cond3.default)([[(0, _test3.default)(/\d+h/), extractNumber(_dateFns.addHours, ref)], [(0, _test3.default)(/\d+d/), extractNumber(_dateFns.addDays, ref)], [(0, _test3.default)(/\d+w/), extractNumber(_dateFns.addWeeks, ref)], [(0, _test3.default)(/\d+m/), extractNumber(_dateFns.addMonths, ref)], [(0, _test3.default)(/\d+y/), extractNumber(_dateFns.addYears, ref)], [(0, _test3.default)(/^eod$/), function () {
		return (0, _dateFns.endOfDay)(ref);
	}], [(0, _test3.default)(/^eom$/), function () {
		return (0, _dateFns.endOfMonth)(ref);
	}], [(0, _test3.default)(/^eow$/), function () {
		return (0, _dateFns.endOfWeek)(ref);
	}], [(0, _test3.default)(/^eoy$/), function () {
		return (0, _dateFns.endOfYear)(ref);
	}], [(0, _test3.default)(/^sod$/), function () {
		return (0, _dateFns.startOfDay)(ref);
	}], [(0, _test3.default)(/^som$/), function () {
		return (0, _dateFns.startOfMonth)(ref);
	}], [(0, _test3.default)(/^sow$/), function () {
		return (0, _dateFns.startOfWeek)(ref);
	}], [(0, _test3.default)(/^soy$/), function () {
		return (0, _dateFns.startOfYear)(ref);
	}], [(0, _test3.default)(/^now$/), function () {
		return ref;
	}], [_T3.default, _chronoNode2.default.parseDate]]);
};

exports.default = parseFrom(new Date());
var parseRecur = exports.parseRecur = (0, _pipe3.default)((0, _match3.default)(/(\d+)([hdwmy])/), function (_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 3),
	    _ = _ref2[0],
	    n = _ref2[1],
	    period = _ref2[2];

	return {
		n: parseInt(n, 10),
		period: period
	};
});