"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _equals2 = require("ramda/src/equals");

var _equals3 = _interopRequireDefault(_equals2);

var _findIndex2 = require("ramda/src/findIndex");

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _sortBy2 = require("ramda/src/sortBy");

var _sortBy3 = _interopRequireDefault(_sortBy2);

var _fromPairs2 = require("ramda/src/fromPairs");

var _fromPairs3 = _interopRequireDefault(_fromPairs2);

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _contains2 = require("ramda/src/contains");

var _contains3 = _interopRequireDefault(_contains2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _filter2 = require("ramda/src/filter");

var _filter3 = _interopRequireDefault(_filter2);

var _toPairs2 = require("ramda/src/toPairs");

var _toPairs3 = _interopRequireDefault(_toPairs2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _reduce2 = require("ramda/src/reduce");

var _reduce3 = _interopRequireDefault(_reduce2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var measureColumnWidths = function measureColumnWidths(config) {
	return (0, _reduce3.default)(function (columnWidths, task) {
		return (0, _extends3.default)({}, columnWidths, (0, _pipe3.default)(_toPairs3.default, (0, _filter3.default)(function (_ref) {
			var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
			    key = _ref2[0];

			return (0, _contains3.default)(key, config.headers);
		}), (0, _map3.default)(function (_ref3) {
			var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
			    key = _ref4[0],
			    value = _ref4[1];

			return [key, Math.max(key.length || 0, value.length || 0, columnWidths[key] || 0, 0)];
		}), _fromPairs3.default)(task));
	}, {});
};

exports.default = function (config) {
	return (0, _pipe3.default)(measureColumnWidths(config), (0, _pipe3.default)(_toPairs3.default, (0, _map3.default)(function (_ref5) {
		var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
		    label = _ref6[0],
		    length = _ref6[1];

		return {
			label: label,
			length: length
		};
	}), (0, _sortBy3.default)(function (_ref7) {
		var label = _ref7.label;
		return (0, _findIndex3.default)((0, _equals3.default)(label), config.headers);
	})));
};