"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _windowSize = require("window-size");

var _windowSize2 = _interopRequireDefault(_windowSize);

var _processTasksForRendering = require("./processTasksForRendering");

var _processTasksForRendering2 = _interopRequireDefault(_processTasksForRendering);

var _generateColumnRenderingInfo = require("./generateColumnRenderingInfo");

var _generateColumnRenderingInfo2 = _interopRequireDefault(_generateColumnRenderingInfo);

var _renderTasksToString = require("./renderTasksToString");

var _renderTasksToString2 = _interopRequireDefault(_renderTasksToString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config, tasks) {
	var _windowSize$get = _windowSize2.default.get(),
	    width = _windowSize$get.width,
	    height = _windowSize$get.height;

	var renderReadyTasks = (0, _processTasksForRendering2.default)({
		config: config,
		height: height
	})(tasks);

	var columnWidths = (0, _generateColumnRenderingInfo2.default)(config)(renderReadyTasks);

	return (0, _renderTasksToString2.default)({
		width: width,
		height: height,
		renderReadyTasks: renderReadyTasks,
		columnWidths: columnWidths
	});
};