"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slice2 = require("ramda/src/slice");

var _slice3 = _interopRequireDefault(_slice2);

var _reverse2 = require("ramda/src/reverse");

var _reverse3 = _interopRequireDefault(_reverse2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

var _sortBy2 = require("ramda/src/sortBy");

var _sortBy3 = _interopRequireDefault(_sortBy2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propEq2 = require("ramda/src/propEq");

var _propEq3 = _interopRequireDefault(_propEq2);

var _findIndex2 = require("ramda/src/findIndex");

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _evolve2 = require("ramda/src/evolve");

var _evolve3 = _interopRequireDefault(_evolve2);

var _join2 = require("ramda/src/join");

var _join3 = _interopRequireDefault(_join2);

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _filter2 = require("ramda/src/filter");

var _filter3 = _interopRequireDefault(_filter2);

var _map2 = require("ramda/src/map");

var _map3 = _interopRequireDefault(_map2);

var _addIndex2 = require("ramda/src/addIndex");

var _addIndex3 = _interopRequireDefault(_addIndex2);

var _fp = require("date-fns/fp");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var map = (0, _addIndex3.default)(_map3.default);

var sigFig = function sigFig(sf) {
	return function (x) {
		return parseFloat(x.toPrecision(sf), 10);
	};
};

var filterTasks = function filterTasks(config) {
	return (0, _filter3.default)(config.filterTask);
};

var addRenderingMetaToTasks = function addRenderingMetaToTasks(config) {
	var giveColor = config.giveColor;

	return map(function (task, i) {
		return (0, _extends3.default)({}, task, {
			i: i,
			score: sigFig(3)(task.score),
			color: giveColor(task)
		});
	});
};

var formatDateDistance = (0, _pipe3.default)(_fp.toDate, (0, _fp.formatDistanceStrictWithOptions)({
	addSuffix: true
})(new Date()));

var addPlusToTags = (0, _pipe3.default)((0, _map3.default)(function (x) {
	return "+" + x;
}), (0, _join3.default)(" "));

var stringfiyTasksFields = function stringfiyTasksFields(tasks) {
	return (0, _map3.default)((0, _pipe3.default)((0, _evolve3.default)({
		created: formatDateDistance,
		done: formatDateDistance,
		due: formatDateDistance,
		start: formatDateDistance,
		stop: formatDateDistance,
		tags: addPlusToTags,
		updated: formatDateDistance,
		wait: formatDateDistance,
		depends: function depends(uuid) {
			return "" + (0, _findIndex3.default)((0, _propEq3.default)("uuid", uuid), tasks);
		},
		recur: function recur(_ref) {
			var n = _ref.n,
			    period = _ref.period;
			return n + " " + {
				d: "days",
				w: "weeks",
				m: "months",
				y: "years"
			}[period];
		}
	}), function (_ref2) {
		var i = _ref2.i,
		    color = _ref2.color,
		    score = _ref2.score,
		    rest = (0, _objectWithoutProperties3.default)(_ref2, ["i", "color", "score"]);
		return (0, _extends3.default)({
			i: i,
			color: color,
			score: score
		}, (0, _map3.default)(function (x) {
			return "" + x;
		}, rest));
	}))(tasks);
};

exports.default = function (_ref3) {
	var config = _ref3.config,
	    height = _ref3.height;
	return (0, _pipe3.default)(filterTasks(config), addRenderingMetaToTasks(config), stringfiyTasksFields, (0, _sortBy3.default)((0, _prop3.default)("score")), _reverse3.default, (0, _slice3.default)(0, height - 4));
};